function searchX(objects, field, params)
	
	local fetchedObjects = checkAllObjects(objects, field, params)
	return fetchedObjects

end

function checkAllObjects(objects, field, params)
	--return array of all objects whose fields contain all search params

	local fetchedObjects = {}
	
	for i=1, #objects do
	
		--check if all params are contained for each single object
		if checkAllParams(objects[i], field, params) == true then
		
			table.insert(fetchedObjects, objects[i])
		
		end
	
	end

	return fetchedObjects

end

function checkAllParams(object, field, params)
	--return false if at least one param is not contained in the current object's field(list)

	local allParamsContained = true
	
	for i=1, #params do
		
		local paramContained = checkParamAgainstObjectField(object, field, params[i])
		
		if paramContained == false then
			allParamsContained = false
		end
		
	end
	
	return allParamsContained

end

function checkParamAgainstObjectField(object, field, param)
	--return true if the passed param is contained in the current object's field(list)

	local paramContained = false
	
	--if field is not a table, treat it as a table with one value
	if type(object[field])~="table" then
		
		if object[field] == param then
			paramContained = true
		end
		
	else 
	
		for i=1, #object[field] do
			if object[field][i] == param then
				paramContained = true
			end
		end
	
	end
	
	return paramContained

end